<template>
	<a-drawer
		:title="formData.id ? '编辑区域价格' : '增加区域价格'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="区域名称：" name="zoneName">
				<a-input v-model:value="formData.zoneName" placeholder="请输入区域" allow-clear/>
			</a-form-item>
			<a-form-item label="区域价格(元/吨)：" name="zonePrice">
				<a-input-number v-model:value="formData.zonePrice" placeholder="请输入区域价格" :min="0.01" :max="10000" style="width: 100%"/>
			</a-form-item>
			<a-form-item label="粮食种类：" name="grainGroup">
				<a-select v-model:value="formData.grainGroup" placeholder="请选择粮食种类" :options="grainGroupOptions"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotZonePriceForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import depotZonePriceApi from '@/api/biz/depotZonePriceApi'
import {required, rules} from '@/utils/formRules'
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const grainGroupOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	}
	grainGroupOptions.value = tool.dictList('粮食种类')
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	zoneName: [required('请输入区域')],
	zonePrice: [required('请输入区域价格'), rules.amountCheck],
	grainGroup: [required('请输入粮食种类')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotZonePriceApi
				.depotZonePriceSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
